#include <sourcemod>
#include <sdktools>
#include <morecolors>

public Plugin:myinfo = 
{
	name = "Draw My ???",
	author = "MPQC",
	description = "A gamemode where one player must draw a specific word, and the others must guess it",
	version = "1.3.0",
	url = "www.steamgamers.com"
}

new g_numspaces; // number of spaces in a given word
new g_printtime; // what we should be printing (ie game starts in 5...4..3..2..1..start)
new g_recentlydone[100]; // holds integer location of the last 100 said words.
new g_currentposition; // determines where we are in the last 100 recently done words
new g_playerpoints[MAXPLAYERS+1]; // holds the current clients location within g_playerscores, so we dont need to constantly search to update their scores
new g_wordguessed[MAXPLAYERS+1]; // will be >0 if someone guessed the word. if == 1, they were first to guess, == 2 is they were drawing and it was guessed, == 3 is everyone else that got it correct after
new g_mapscores[MAXPLAYERS+1]; // holds the players current score, only for the current map
new g_currentturn; // who is the current drawer
new g_numplaying; // number of people playing
new g_timeleft; // how much time left in the round
new g_numhints; // number of hints given so far
new g_lasersize; // size of the laser
new g_amountrepeats; // number of repeats in a given 

new bool:g_alreadyforfeited; // when the person has already forfeited, this is true, so they can't spam forfeit
new bool:g_isblackdefault = false; // an optional entity the map creator can place in the map. if they place the entity they can swap the default color to black, or just leave it at white
new bool:g_allowedtodraw; // allowed to draw, also used as "allowedtoguess", since they both would be set to the same value at the same time
new bool:g_firstguess; // if nobody has guessed correctly, this is false
new bool:g_wordhint[32]; // true for each index that will be shown in a hint
new bool:g_roundstarted; // if the round has started
new bool:g_players_playing[MAXPLAYERS+1]; // index will be true when that player is playing
new bool:g_ispunished[MAXPLAYERS+1]; // if the admin has decided to not them play anymore (breaking rules...drawing penises..whatever the admin deems unfit) then we check for that here
new bool:g_doesntwanttodraw[MAXPLAYERS+1] // if the player doesn't want to draw, this will be true, and it will skip their turn
new bool:g_istherewinner; // if someone is winning, this is true
new bool:g_isDrawing; // if they're drawing :D
new bool:g_notafk; // just to make sure to clear out an afk drawer, waiting 60 seconds is boring
new bool:g_teleportersonmap; // if there are teleporters on the map (so we can teleport the drawers & guessers)

new Handle:g_playerscores = INVALID_HANDLE; // array that holds each persons scores thats ever entered the server
new Handle:g_lasers = INVALID_HANDLE; // holds the players lasers (entity numbers), used so the player can undo and laser cleanup
new Handle:g_wordlist = INVALID_HANDLE; // soon to be an adt_array to hold every word that the user provides

new Handle:g_hamtrepeat = INVALID_HANDLE; // convar so a person can change the amount of repeats

new String:g_colorchosen[64]; // which color they choose
new String:g_word[32]; // the current word that must be guessed

new Float:g_drawerlocation[3]; // where to teleport the person that will be drawing
new Float:g_guesserlocation[3]; // where to teleport the person(s) that will be guessing
new Float:g_lastlaser[3]; // where the last laser was

public OnPluginStart()
{
	LoadTranslations("common.phrases");
	
	AddDownloads();
	
	RegConsoleCmd("sm_menu", MenuCheck);
	RegConsoleCmd("sm_score", ScoreCheck);
	RegConsoleCmd("sm_rank", ScoreCheck);
	RegConsoleCmd("sm_help", Help);
	RegConsoleCmd("sm_skip", Skip);
	RegConsoleCmd("sm_top10", Top10Check);
	
	RegAdminCmd("sm_disabledraw", Command_DisableDraw, ADMFLAG_BAN, "Disables a player from drawing until map change");
	
	AddCommandListener(Command_Say, "say");
	AddCommandListener(Command_Say, "say_team");
	AddCommandListener(Command_Jointeam, "jointeam");
	
	HookEvent("player_disconnect", PlayerLeave, EventHookMode_Pre); 
	HookEvent("player_death", EventPlayerDeath);
	
	g_hamtrepeat = CreateConVar("dr_amountrepeats", "100", "Default amount of words to check for repeats", FCVAR_PLUGIN|FCVAR_NOTIFY);
	HookConVarChange(g_hamtrepeat, RepeatConVarChanged);
	AutoExecConfig(true, "drawmy");
	
	/* DEBUG COMMANDS, ONLY ENABLE IF DEBUGGING */
	//RegConsoleCmd("getscores", GetScores);
	//RegConsoleCmd("getindex", GetIndex);
	//RegConsoleCmd("printrecent", PrintRecent);
	//RegConsoleCmd("fakewin", FakeWin);
	//RegConsoleCmd("erase", Erase);
	//RegConsoleCmd("hintcheck", HintCheck);
	
	g_roundstarted = false;
	g_currentturn = 1;
	g_word = "blank"; // default lol
	g_wordlist = CreateArray(32); // set up our word list
	g_lasers = CreateArray(1); // set up our laser array 
	new bool:wordsuccess = BuildWordList();
	if (!wordsuccess)
	{
		SetFailState("Word list loading failed; check for errors");
	}
	
	for (new i = 0; i < 100; i++)
	{
		g_recentlydone[i] = -1;
	}
	g_currentposition = 0;
}

public OnMapStart()
{
	g_isblackdefault = false; // by default we set this to black..then we search the teleporters, if we find required entities we change it to white
	g_teleportersonmap = FindTeleporters();
	new bool:precache = ((PrecacheModel("draw/black.vmt") > 0) && (PrecacheModel("draw/brown.vmt") > 0) && (PrecacheModel("draw/white.vmt") > 0) && (PrecacheModel("draw/blue.vmt") > 0) && (PrecacheModel("draw/white.vmt") > 0) && (PrecacheModel("draw/blue.vmt") > 0) && (PrecacheModel("draw/green.vmt") > 0) && (PrecacheModel("draw/grey.vmt") > 0) && (PrecacheModel("draw/orange.vmt") > 0) && (PrecacheModel("draw/pink.vmt") > 0) && (PrecacheModel("draw/purple.vmt") > 0) && (PrecacheModel("draw/red.vmt") > 0) && (PrecacheModel("draw/yellow.vmt") > 0));
	if (precache)
	{
		new bool:scores = LoadScores();
		BubbleSortScores(); // after we load the scores, we'll sort them immediately to avoid lag for when players type rank
		if (scores)
		{
			CreateTimer(1.0, UpdateRound, _, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			CreateTimer(0.1, Timer_Pay, _, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE); // This function is taken from Mitchell's LASERRRRRRRRSSSS plugin. All credits to him for it.
		}
		else
		{
			SetFailState("Failed to load high scores! Make sure the file is there.");
		}
	}
	else
	{
		SetFailState("Failed to load required materials. Check installation.");
	}
}

public OnMapEnd()
{
	EraseLasers();
	
	for (new i = 0; i <= MaxClients; i++)
	{
		g_doesntwanttodraw[i] = false;
		g_ispunished[i] = false;
		g_mapscores[i] = 0;
	}
	
	decl String:path[PLATFORM_MAX_PATH];
	BuildPath(Path_SM, path, PLATFORM_MAX_PATH, "configs/drawscores.txt");
	new Handle:wordfile = OpenFile(path, "w");
	new size = GetArraySize(g_playerscores);
	
	decl String:steamid[32];
	decl String:playername[64];
	new cell;
	
	for (new i = 0; i < size; i=i+3)
	{
		cell = GetArrayCell(g_playerscores, i+1);
		if (cell != 0)
		{
			GetArrayString(g_playerscores, i, steamid, sizeof(steamid));
			GetArrayString(g_playerscores, i+2, playername, sizeof(playername));
			WriteFileLine(wordfile, steamid);
			WriteFileLine(wordfile, "%i", cell);
			WriteFileLine(wordfile, playername);
		}
	}
	
	CloseHandle(wordfile);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////                SETUP                ///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool:LoadScores()
{
	if (g_playerscores == INVALID_HANDLE)
	{
		g_playerscores = CreateArray(8);
		decl String:path[PLATFORM_MAX_PATH];
		BuildPath(Path_SM, path, PLATFORM_MAX_PATH, "configs/drawscores.txt");
		new Handle:wordfile = OpenFile(path, "r");
		if (wordfile == INVALID_HANDLE)
		{
			return false;
		}
		decl String:currentword[64];
		new currentnumber;
		while(ReadFileLine(wordfile, currentword, sizeof(currentword))) // keep reading until end of file...
		{
			// we read the players steamid, check for \n (which every line will have except the last), and remove \n
			if (currentword[strlen(currentword)-1] == '\n')
			{
				currentword[strlen(currentword)-1] = '\0'; // strip \n
			}
			
			// push it onto our array
			PushArrayString(g_playerscores, currentword);
			
			// read the next line, which is their score
			ReadFileLine(wordfile, currentword, sizeof(currentword))
			if (currentword[strlen(currentword)-1] == '\n')
			{
				currentword[strlen(currentword)-1] = '\0'; // strip \n
			}
			
			// convert it to an int
			currentnumber = StringToInt(currentword);
			PushArrayCell(g_playerscores, currentnumber);
			
			// lastly we read their name, recycling "currentword" just because we can
			ReadFileLine(wordfile, currentword, sizeof(currentword))
			
			// strip it as usual..
			if (currentword[strlen(currentword)-1] == '\n')
			{
				currentword[strlen(currentword)-1] = '\0'; // strip \n
			}
			
			PushArrayString(g_playerscores, currentword); // add their name to our array
			
			// so our array is now set up as follows:
			// steamid
			// score
			// player name
		}
		
		CloseHandle(wordfile);
	}
	return true;
}

bool:FindTeleporters()
{
	decl String:classname[64];
	decl String:targetname[64];
	new max = GetMaxEntities();
	new bool:foundguesser = false;
	new bool:founddrawer = false;
	
	for (new i = 0; i < max; i++)
	{
		if(!IsValidEntity(i))
		{
			continue;
		}
		
		GetEdictClassname(i,classname,sizeof(classname));
		
		if (StrEqual(classname, "info_teleport_destination"))
		{
			GetEntPropString(i, Prop_Data, "m_iName", targetname, sizeof(targetname));
			
			if (StrEqual(targetname, "teleportguesser"))
			{
				foundguesser = true;
				GetEntPropVector(i, Prop_Send, "m_vecOrigin", g_guesserlocation);
			}
			else if (StrEqual(targetname, "teleportdrawer"))
			{
				founddrawer = true;
				GetEntPropVector(i, Prop_Send, "m_vecOrigin", g_drawerlocation);
			}
			else if (StrEqual(targetname, "black"))
			{
				g_isblackdefault = true;
			}
		}
	}
	
	// if we found both, then this map supports teleporters
	if (foundguesser && founddrawer)
	{
		return true;
	}
	// else, don't teleport because it'll crash :(
	return false;
}

bool:BuildWordList()
{
	if (g_wordlist != INVALID_HANDLE)
	{
		decl String:path[PLATFORM_MAX_PATH];
		BuildPath(Path_SM, path, PLATFORM_MAX_PATH, "configs/wordlist.txt");
		new Handle:wordfile = OpenFile(path, "r");
		decl String:currentword[32];
		while(ReadFileLine(wordfile, currentword, sizeof(currentword)))
		{
			if (currentword[strlen(currentword)-1] == '\n')
			{
				currentword[strlen(currentword)-1] = '\0'; // strip \n
			}
			PushArrayString(g_wordlist, currentword);
		}
		
		CloseHandle(wordfile);
		return true;
	}
	return false;
}

bool:SetupRound()
{
	new bool:someoneplaying = false;
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i))
		{
			if (IsPlayerAlive(i)) // makes sure they're playing rather then doing a team check for no spec or neither
			{
				g_players_playing[i] = true;
				someoneplaying = true;
				g_numplaying = g_numplaying + 1;
			}
		}
	}
	g_printtime = 1;
	g_timeleft = 65;
	g_numhints = 0;
	g_istherewinner = false;
	g_lasersize = 1;
	g_isDrawing = false;
	g_allowedtodraw = false;
	g_firstguess = false;
	g_alreadyforfeited = false;
	g_numspaces = 0;
	g_notafk = false;
	//g_ismoreoneword = false;
	if (!g_isblackdefault)
	{
		strcopy(g_colorchosen, sizeof(g_colorchosen), "draw/white.vmt");
	}
	else
	{
		strcopy(g_colorchosen, sizeof(g_colorchosen), "draw/black.vmt");
	}
	g_lastlaser[0] = 0.0; g_lastlaser[1] = 0.0; g_lastlaser[2] = 0.0; 
	for (new i = 0; i < 32; i++)
	{
		g_wordhint[i] = false;
	}
	
	return someoneplaying;
}

AddDownloads()
{
	AddFileToDownloadsTable("materials/draw/black.vmt");
	AddFileToDownloadsTable("materials/draw/black.vtf");
	AddFileToDownloadsTable("materials/draw/blue.vmt");
	AddFileToDownloadsTable("materials/draw/blue.vtf");
	AddFileToDownloadsTable("materials/draw/brown.vmt");
	AddFileToDownloadsTable("materials/draw/brown.vtf");
	AddFileToDownloadsTable("materials/draw/green.vmt");
	AddFileToDownloadsTable("materials/draw/green.vtf");
	AddFileToDownloadsTable("materials/draw/grey.vmt");
	AddFileToDownloadsTable("materials/draw/grey.vtf");
	AddFileToDownloadsTable("materials/draw/orange.vmt");
	AddFileToDownloadsTable("materials/draw/orange.vtf");
	AddFileToDownloadsTable("materials/draw/pink.vmt");
	AddFileToDownloadsTable("materials/draw/pink.vtf");
	AddFileToDownloadsTable("materials/draw/purple.vmt");
	AddFileToDownloadsTable("materials/draw/purple.vtf");
	AddFileToDownloadsTable("materials/draw/red.vmt");
	AddFileToDownloadsTable("materials/draw/red.vtf");
	AddFileToDownloadsTable("materials/draw/white.vmt");
	AddFileToDownloadsTable("materials/draw/white.vtf");
	AddFileToDownloadsTable("materials/draw/yellow.vmt");
	AddFileToDownloadsTable("materials/draw/yellow.vtf");
}

public RepeatConVarChanged(Handle:convar, const String:oldValue[], const String:newValue[])
{
	if (convar == g_hamtrepeat)
	{
		g_amountrepeats = StringToInt(oldValue);
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////         DRAWING FUNCTION            ///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

public Action:PlayerLeave(Handle:event, const String:name[], bool:dontBroadcast)
{
	new clientid = GetEventInt(event,"userid"); 
	new client = GetClientOfUserId(clientid); 
	
	g_ispunished[client] = false;
	g_doesntwanttodraw[client] = false;
	if (client == g_currentturn)
	{
		PrintToChatAll("Oh no! The current drawer has left! Ending the round.");
		if (g_timeleft > 6)
		{
			g_timeleft = 6;
		}
	}
	g_wordguessed[client] = 0;
	g_mapscores[client] = 0;
	return Plugin_Continue;
}

public OnClientAuthorized(client, const String:auth[])
{
	FindNewPlayerLocations(client);
	return;
}

public Action:EventPlayerDeath(Handle:event, const String:name[], bool:dontBroadcast) 
{
	new clientid = GetEventInt(event,"userid"); 
	new client = GetClientOfUserId(clientid); 
	
	if (client == g_currentturn)
	{
		PrintToChatAll("Oh no! The current drawer is gone! Ending the round.");
		if (g_timeleft > 6)
		{
			g_timeleft = 5;
		}
	}
	g_wordguessed[client] = 0;
	return Plugin_Handled;
}

public Action:ChooseAWord(client, args)
{
	ChooseWord();
	return Plugin_Handled;
}

public Action:Help(client, args)
{
	PrintToChat(client, "Each round a player is chosen to draw a certain word.")
	PrintToChat(client, "If you are chosen to draw, you must draw what it tells you to in chat.")
	PrintToChat(client, "If you are a guesser, you must guess what the drawer is drawing. Type your guess in chat.")
	PrintToChat(client, "Available commands: !help, !menu, !score, !rank, !forfeit, !skip.")
	return Plugin_Handled;
}

public Action:Skip(client, args)
{
	if (g_doesntwanttodraw[client])
	{
		PrintToChat(client, "You are no longer skipping your turn.");
		g_doesntwanttodraw[client] = false;
	}
	else
	{
		PrintToChat(client, "You are now skipping your turn.");
		g_doesntwanttodraw[client] = true;
	}
	return Plugin_Handled;
}

TraceEye(client, Float:pos[3])
{
	decl Float:vAngles[3], Float:vOrigin[3];
	GetClientEyePosition(client, vOrigin);
	GetClientEyeAngles(client, vAngles);
	TR_TraceRayFilter(vOrigin, vAngles, MASK_SHOT, RayType_Infinite, TraceEntityFilterPlayer);
	if(TR_DidHit(INVALID_HANDLE)) TR_GetEndPosition(pos, INVALID_HANDLE);
	return;
}

stock DrawLaser(Float:start[3], Float:end[3])
{
	if (g_allowedtodraw)
	{
		new ent = CreateEntityByName("env_beam");
		g_notafk = true;
		if (ent != -1)
		{
			TeleportEntity(ent, start, NULL_VECTOR, NULL_VECTOR);
			SetEntityModel(ent, g_colorchosen);
			SetEntPropVector(ent, Prop_Data, "m_vecEndPos", end);
			DispatchKeyValue(ent, "targetname", "beam");
			DispatchKeyValue(ent, "rendercolor", "255 255 255");
			decl String:amt[32];
			Format(amt, sizeof(amt), "%i", 100);
			DispatchKeyValue(ent, "renderamt", amt);
			DispatchSpawn(ent);
			SetEntPropFloat(ent, Prop_Data, "m_fWidth", float(g_lasersize));
			SetEntPropFloat(ent, Prop_Data, "m_fEndWidth", float(g_lasersize));
			ActivateEntity(ent);
			AcceptEntityInput(ent, "TurnOn");
			PushArrayCell(g_lasers, ent);
		}
		else
		{
			PrintToChat(g_currentturn, "You've hit the maximum drawing limit :("); // pretty sure this is actually impossible to hit in 60 seconds (that's 170 lasers per second...impossible)
																				   // but it's better to be safe than sorry, so let's have it here. Perhaps if the map has thousands of entities? lol
		}
	}
}

public Action:Timer_Pay(Handle:timer)
{
	// Code taken from Mitchel's LASERRRRRRRRRS plugin. All credits to him.
	new Float:pos[3];
	if (IsClientInGame(g_currentturn))
	{
		if (GetClientButtons(g_currentturn) & IN_ATTACK)
		{
			g_isDrawing = true;
		}
		else
		{
			g_isDrawing = false;
			TraceEye(g_currentturn, pos);
			g_lastlaser[0] = pos[0];
			g_lastlaser[1] = pos[1];
			g_lastlaser[2] = pos[2];
		}
		if (g_isDrawing)
		{
			TraceEye(g_currentturn, pos);
			if(GetVectorDistance(pos, g_lastlaser) > 4.0)
			{
				DrawLaser(g_lastlaser, pos);
				g_lastlaser[0] = pos[0];
				g_lastlaser[1] = pos[1];
				g_lastlaser[2] = pos[2];
			}
		}
	}
}

EraseLasers()
{
	new size = GetArraySize(g_lasers);
	if (size > 0)
	{
		for (new i = 0; i < size; i++)
		{
			new ent = GetArrayCell(g_lasers, i);
			if (IsValidEdict(ent))
			{
				AcceptEntityInput(ent, "Kill");
			}
		}
		ClearArray(g_lasers);
	}
}

public Action:PDrawLaser(client, args)
{
	// Code taken from Mitchel's LASERRRRRRRRRS plugin. All credits to him.
	if (client == g_currentturn)
	{
		TraceEye(client, g_lastlaser);
		g_isDrawing = true;
	}
	return Plugin_Handled;
}

public bool:TraceEntityFilterPlayer(entity, contentsMask)
{
	return (entity > GetMaxClients() || !entity);
}

ResetCurrentlyPlaying()
{
	for (new i = 1; i <= MaxClients; i++)
	{
		g_players_playing[i] = false;
		g_wordguessed[i] = 0;
	}
	g_numplaying = 0;
}

NextPersonsTurn()
{
	new tempcurrent = g_currentturn + 1;
	new bool:notfound = true;
	new counter = 0;
	while(notfound)
	{
		if (tempcurrent == g_currentturn)
		{
			return tempcurrent; // if tempcurrent is equal to currentturn, then we've looped through all players, meaning there is only one person in the game
		}
		if (counter > 100) // failsafe incase we head into infinite loop
		{
			return g_currentturn;
		}
		if (tempcurrent > MaxClients)
		{
			tempcurrent = 1;
		}
		if (g_players_playing[tempcurrent])
		{
			if (!g_ispunished[tempcurrent]) // if an admin didn't punish this player, let's accept them for the current turn
			{
				if (!g_doesntwanttodraw[tempcurrent])
				{
					g_currentturn = tempcurrent;
					return g_currentturn;
				}
			}
		}
		tempcurrent = tempcurrent + 1;
		counter = counter + 1;
	}
	return g_currentturn; // will never actually make it here, but compiler warnings....
}

bool:CheckRepeat(number)
{
	new bool:found = false;
	for (new i = 0; i < g_amountrepeats; i++)
	{
		if (g_recentlydone[i] == number)
		{
			found = true;
		}
	}
	return found;
}

ChooseWord()
{
	new random;
	do
	{
		random = GetRandomInt(0, GetArraySize(g_wordlist)-1); // it must be size-1 or else we'll be larger then the array! that will crash the server, bad bad bad
	} while (CheckRepeat(random))
	
	GetArrayString(g_wordlist, random, g_word, sizeof(g_word));
	g_recentlydone[g_currentposition] = random;
	g_currentposition = g_currentposition + 1;
	if (g_currentposition == 100)
	{
		g_currentposition = 0;
	}
	
	// Now we have the word that we're using, let's check if it's a word that contains more then one word, like "baseball bat"
	
	for (new i = 0; i < strlen(g_word); i++)
	{
		if (g_word[i] == ' ')
		{
			//g_ismoreoneword = true;
			g_wordhint[i] = true; // since this will be a space, we want to show that to the players by default
			g_numspaces = g_numspaces + 1;
		}
	}
}

public Action:PrintTimer(Handle:timer)
{
	if (g_printtime == 1)
	{
		PrintCenterTextAll("Game begins in 5");
	}
	else if (g_printtime == 2)
	{
		PrintCenterTextAll("Game begins in 4");
	}
	else if (g_printtime == 3)
	{
		PrintCenterTextAll("Game begins in 3");
	}
	else if (g_printtime == 4)
	{
		PrintCenterTextAll("Game begins in 2");
	}
	else if (g_printtime == 5)
	{
		PrintCenterTextAll("Game begins in 1");
		EraseLasers(); // we erase the lasers here so people have time to look at the picture after the round is over
		g_allowedtodraw = true;
		MainMenu(g_currentturn);
	}
	else
	{
		PrintCenterTextAll("Game starting!");
		return Plugin_Stop;
	}
	g_printtime = g_printtime + 1;
	return Plugin_Continue;
}

PrintSetupInfoToPlayers(client)
{
	decl String:playername[64];
	GetClientName(client, playername, sizeof(playername));
	CPrintToChatAll("The current drawer is {green}%s", playername);
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i))
		{
			if (g_players_playing[i])
			{
				if (client == i)
				{
					PrintToChat(i, "If you close the menu, type !menu at any time to bring it back!");
					CPrintToChat(i, "YOUR WORD: {green}%s.", g_word);
				}
			}
		}
	}
	CreateTimer(1.0, PrintTimer, _,TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE)
}

SetHint()
{
	new length = strlen(g_word)-1;
	if (g_numhints < length)
	{
		new random = GetRandomInt(0, strlen(g_word)-1);
		if (!g_wordhint[random])
		{
			//PrintToChatAll("Gave out first hint");
			g_wordhint[random] = true;
		}
		else
		{
			do // I've actually used a do{}while loop in a useful way, I'M ON A ROLL! :D
			{
				random = GetRandomInt(0, length);
			} while (g_wordhint[random])
			g_wordhint[random] = true;
		}
		g_numhints = g_numhints + 1;
	}
}

UpdateHintAndPrint()
{
	// Time Left: 
	new String:timeleft[3]; timeleft[0] = '\0';
	IntToString(g_timeleft, timeleft, sizeof(timeleft));
	// \nHint: 
	new String:hint[32]; hint[0] = '\0';
	// \n
	new String:length[64]; length[0] = '\0';
	// \n%i Words Total, g_numspaces+1);
	
	if (g_timeleft <= 50) // After 50 seconds, we print out what the word looks like. Ie if the word was "test", it would show _ _ _ _.
	{
		if ((g_timeleft == 35) || (g_timeleft == 40)) // if the word is reaaallllyyy long, even more hints!
		{
			if ((strlen(g_word)-g_numspaces) > 10) // we subtract g_numspaces becase we want to know how many actual letters are in the word, the spaces are given by default
			{
				SetHint();
			}
		}
		
		if (g_timeleft == 50)
		{
			if (IsClientInGame(g_currentturn))
			{
				if (!g_notafk) // if they're afk, give them a heads up
				{
					PrintToChat(g_currentturn, "You have 10 seconds to begin drawing.");
				}
			}
		}
		
		if (g_timeleft == 40) // bad style since we check for 30 twice...oh well...
		{
			if (!g_notafk) // if they're still afk, boot them off :(
			{
				AfkEnd();
			}
		}
		
		if ((g_timeleft == 30) || (g_timeleft == 25)) // if the word is longer then normal, we give the players extra hints
		{
			if ((strlen(g_word)-g_numspaces) > 7)
			{
				SetHint();
			}
		}
		
		if ((g_timeleft == 20)|| (g_timeleft == 15) || (g_timeleft == 10) || (g_timeleft == 5)) // When it's at these values, that's when we know its time to update
		{
			SetHint();
		}	
		
		// We build the hint here
		for (new i = 0; i < strlen(g_word); i++) 
		{
			if (g_wordhint[i])
			{
				hint[i] = g_word[i];
			}
			else
			{
				hint[i] = '_';
			}
		}
		hint[strlen(g_word)] = '\0'; // make sure it's null terminated so we can use strcat to append our timeleft in the round
		
		if (g_numspaces == 0) // if the number of spaces is 0, then we know its a single word and we can just count up the actual length of the word
		{
			Format(length, sizeof(length), "\n%i Letters", strlen(g_word));
		}
		else // if it's not 0, then we must count up the length between spaces
		{
			decl String:templength[32]; templength[0] = '\0';
			new counter = 0;
			for (new i = 0; i < strlen(g_word); i++)
			{
				if (g_word[i] != ' ')
				{
					counter = counter + 1;
				}
				else
				{
					Format(templength, sizeof(templength), "%i letters, ", counter);
					StrCat(length, sizeof(length), templength);
					counter = 0;
				}
			}
			// since there wont be a space at the end, we must manually add the last word amount :D
			Format(templength, sizeof(templength), "%i letters", counter);
			StrCat(length, sizeof(length), templength);
		}
	}
	
	// combine them into giant message :D
	// i have no clue why, but if i decl these, it completely screws up hint box. while i'd rather not use new on big strings, it works, so i'll take it
	decl String:message[192]; message[0] = '\0';
	decl String:messagedrawer[192]; messagedrawer[0] = '\0';
	
	// if the timeleft is less than 50, then we want to start printing hints as well. if it's not, then we don't want to include hints
	if (g_timeleft <= 50)
	{
		if (g_numspaces == 0) // for the default word list, it has higher chance of being 0, so lets just check that first
		{
			Format(message, sizeof(message), "Time Left: %s\nHint: %s%s", timeleft, hint, length);
			Format(messagedrawer, sizeof(messagedrawer), "Time Left: %s\nHint: %s%s\nYour Word: %s", timeleft, hint, length, g_word);
		}
		else
		{
			Format(message, sizeof(message), "Time Left: %s\nHint: %s\n%s\n%i Words Total", timeleft, hint, length, g_numspaces+1);
			Format(messagedrawer, sizeof(messagedrawer), "Time Left: %s\nHint: %s\n%s\n%i Words Total\nYour Word: %s", timeleft, hint, length, g_numspaces+1, g_word);
		}
	}
	else
	{
		Format(message, sizeof(message), "Time Left: %s", timeleft);
		if (g_numspaces == 0)
		{
			Format(messagedrawer, sizeof(messagedrawer), "Time Left: %s\nYour Word: %s", timeleft, g_word);
		}
		else
		{
			Format(messagedrawer, sizeof(messagedrawer), "Time Left: %s%s\nYour Word: %s", timeleft, length, g_word);
		}
	}
	
	// Print it off to everyone :D
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i))
		{
			if (i != g_currentturn)
			{
				PrintHintText(i, message);
			}
			else
			{
				PrintHintText(i, messagedrawer);
			}
		}
	}
}

TeleportToLocations()
{
	// if the map supporters teleporters, teleport people, otherwise we'll just ignore this
	if (g_teleportersonmap)
	{
		for (new i = 1; i <= MaxClients; i++)
		{
			if (IsClientInGame(i))
			{
				if (g_players_playing[i])
				{
					if (i == g_currentturn)
					{
						TeleportEntity(i, g_drawerlocation, NULL_VECTOR, NULL_VECTOR);
					}
					else
					{
						TeleportEntity(i, g_guesserlocation, NULL_VECTOR, NULL_VECTOR);
					}
				}
			}
		}
	}
}

bool:IsSomeonePlaying()
{
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i))
		{
			if (IsPlayerAlive(i))
			{
				return true;
			}
		}
	}
	return false;
}

public Action:UpdateRound(Handle:timer)
{
	if (!g_roundstarted)
	{
		if (IsSomeonePlaying())
		{
			ResetCurrentlyPlaying();
			new bool:someoneplaying = SetupRound();
			
			if (someoneplaying)
			{
				g_printtime = 1;
				new playersturn = NextPersonsTurn();
				ChooseWord();
				TeleportToLocations();
				PrintSetupInfoToPlayers(playersturn);
				g_roundstarted = true;
			}
		}
	}
	else
	{
		g_timeleft = g_timeleft - 1;
		if (g_timeleft <= 60)
		{
			if (g_timeleft > 0)
			{
				UpdateHintAndPrint();
			}
			else
			{
				if (g_istherewinner)
				{
					new String:winnernames[256]; winnernames[0] = '\0'; // i had trouble with just setting the text, so i abuse StrCat lol, bad style but works
					//StrCat(winnernames, sizeof(winnernames), "The round is over! The word was: ");
					//StrCat(winnernames, sizeof(winnernames), g_word);
					StrCat(winnernames, sizeof(winnernames), "The winner(s) are: ");
					for (new i = 1; i <= MaxClients; i++)
					{
						if (g_wordguessed[i] > 0)
						{
							if (IsClientInGame(i))
							{
								new points = GetArrayCell(g_playerscores, g_playerpoints[i]+1)
								points = points + 4 - g_wordguessed[i]
								g_mapscores[i] = g_mapscores[i] + 4 - g_wordguessed[i];
								SetEntProp(i, Prop_Data, "m_iFrags", g_mapscores[i]);
								SetEntProp(i, Prop_Data, "m_iDeaths", 0);
								SetArrayCell(g_playerscores, g_playerpoints[i]+1, points);
								//g_playerpoints[i] = 4 - g_wordguessed[i]; // gives them correct amount of points
								decl String:playername[64];
								GetClientName(i, playername, sizeof(playername));
								StrCat(winnernames, sizeof(winnernames), playername);
								StrCat(winnernames, sizeof(winnernames), ",");
							}
						}
					}
					winnernames[strlen(winnernames)-1] = '\0';
					PrintToChatAll(winnernames);
					
					g_roundstarted = false;
					
					for (new i = 1; i <= MaxClients; i++)
					{
						if (IsClientInGame(i))
						{
							if (g_wordguessed[i] == 1)
							{
								CPrintToChat(i, "You came in first place! You gained {green}3 Points");
							}
							else if (g_wordguessed[i] == 2)
							{
								CPrintToChat(i, "Your drawing was correctly guessed! You gained {green}2 Points");
							}
							else if (g_wordguessed[i] == 3)
							{
								CPrintToChat(i, "You weren't the first person to guess the word. You gained {green}1 Point");
							}
						}
					}
					CPrintToChatAll("The word was: {green}%s", g_word);
				}
				else
				{
					CPrintToChatAll("The round is over! There are no winners! The word was: {green}%s.", g_word);
				}
				new timeleft;
				GetMapTimeLeft(timeleft);
				
				if (timeleft <= 1)
				{
					PrintToChatAll("The game is over!");
					
					// Once the time is over, then we want to kill everybody which will force a map change.
					for (new i = 1; i <= MaxClients; i++)
					{
						if (IsClientInGame(i))
						{
							if (IsPlayerAlive(i))
							{
								ForcePlayerSuicide(i);
							}
						}
					}
					EraseLasers();
				}
				g_allowedtodraw = false; // people could potentially draw after the game ended, so let's stop that
				g_roundstarted = false;
			}
		}
	}
}

bool:CheckAndDealWithText(client)
{
	if (client != g_currentturn)
	{
		if (g_players_playing[client])
		{
			if (g_wordguessed[client] == 0)
			{
				if (g_allowedtodraw)
				{
					decl String:playername[64];
					GetClientName(client, playername, sizeof(playername));
					PrintToChatAll("%s Has guessed the word!", playername);
					
					if (!g_firstguess)
					{
						if (g_timeleft > 6)
						{
							g_timeleft = 6; // someone has guessed the word, end the round quickly
						}
						g_wordguessed[client] = 1;
						g_wordguessed[g_currentturn] = 2;
						g_firstguess = true;
					}
					else
					{
						g_wordguessed[client] = 3;
					}
					g_istherewinner = true;
					return true;
				}
			}
		}
		else
		{
			PrintToChat(client, "You joined late and aren't playing this round. Wait until next round!");
		}
	}
	else
	{
		return true;
	}
	return false;
}

public Action:Command_Say(client, const String:command[], argc)
{
	decl String:text[192]; text[0]='\0';
	GetCmdArgString(text, sizeof(text)) // gets the current message
	
	new startidx = 0
	if (text[0] == '"')
	{
		startidx = 1
		/* Strip the ending quote, if there is one */
		// taken off the sourcemod wiki
		new len = strlen(text);
		if (text[len-1] == '"')
		{
			text[len-1] = '\0'
		}
	}
	if (StrEqual(text[startidx], "!forfeit")) // if they say !forfeit, then end their round
	{
		if (client == g_currentturn)
		{
			Forfeit();
		}
	}
	else if (StrEqual(text[startidx], "rank")) // if they say !forfeit, then end their round
	{
		DisplayRank(client);
	}
	else if (StrEqual(text[startidx], "top10")) // if they say !forfeit, then end their round
	{
		Top10(client);
	}
	else if (StrEqual(text[startidx], "help"))
	{
		Help(client, client);
	}
	else if (StrEqual(text[startidx], "skip"))
	{
		Skip(client, client);
	}
	else if(StrEqual(text[startidx], g_word, false)) // first we check if the word is literally equal, ie if the word is "horse", and they guess "horse"
	{
		if (CheckAndDealWithText(client))
		{
			return Plugin_Handled;
		}
		return Plugin_Continue;
	}
	else if (text[strlen(text[startidx])] == 's') // check if there is a minor typo, ie if the word is "horse", and they guess "horses", we still want to accept that as correct
	{
		text[strlen(text[startidx])] = '\0'; // to accept it as correct, we chop off the last letter (ie the s), and check if it's equal again
		if(StrEqual(text[startidx], g_word, false))
		{
			if (CheckAndDealWithText(client))
			{
				return Plugin_Handled;
			}
			return Plugin_Continue;
		}
	}
	else // if we made it here, then there is no s at the end. So let's put one there and see if its correct. (ie they guess "horse", and the word is "horses"), we also want to accept that
	{
		new length = strlen(text[startidx]); // since we will be removing the \0, we must get the length here, else we would crash when trying to call strlen again :[
		text[length+1] = 's';
		text[length+2] = '\0'; 
		if(StrEqual(text[startidx], g_word, false)) // okay we've added the s, let's check if it's correct now
		{
			if (CheckAndDealWithText(client))
			{
				return Plugin_Handled;
			}
			return Plugin_Continue;
		}
	}
	
	// all preliminary checking is done.. if we reached this point, it's obviously not correct (or their spelling is bad), oh well... pass on the message as usual
	return Plugin_Continue;
}

public Action:Command_Jointeam(client, const String:command[], argc)
{
	decl String:text[192]; text[0] = '\0';
	GetCmdArgString(text, sizeof(text));
 
	new startidx = 0
	if (text[0] == '"')
	{
		startidx = 1
		/* Strip the ending quote, if there is one */
		new len = strlen(text);
		if (text[len-1] == '"')
		{
			text[len-1] = '\0'
		}
	}
	//if ((StrEqual(text[startidx], "2")) || (StrEqual(text[startidx], "3")) || (StrEqual(text[startidx], "0"))) // check for t, ct, and auto assign respectively
	if (!StrEqual(text[startidx], "1"))
	{
		g_players_playing[client] = true;
		g_numplaying = g_numplaying + 1;
	}
	else
	{
		g_players_playing[client] = false;
	}
	return Plugin_Continue;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////                ADMIN                ///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

public Action:Command_DisableDraw(client, args)
{
	
	if (args != 1)
	{
		ReplyToCommand(client, "[SM] Usage: sm_disabledraw <name|#userid>");
		return Plugin_Handled;	
	}	
	
	decl String:starget[64]; starget[0] = '\0';
	GetCmdArg(1, starget, sizeof(starget));
	
	new target = FindTarget(client, starget);
	if (target == -1)
	{
		return Plugin_Handled;
	}
	
	if (!g_ispunished[target]) // if they're not punished, let's punish them
	{
		g_ispunished[target] = true;
		
		if (target == g_currentturn) // if the person we're punishing is currently drawing, let's end their turn. rage :[
		{
			decl String:playername[64];
			GetClientName(g_currentturn, playername, sizeof(playername));
			PrintToChatAll("%s is not allowed to draw anymore. Ending the round.", playername);
			g_timeleft = 2;
			g_alreadyforfeited = true;
		}
	}
	else // if they're already punished, lets unpunish them
	{
		decl String:playername[64];
		GetClientName(g_currentturn, playername, sizeof(playername));
		PrintToChatAll("%s is allowed to draw again.", playername);
		g_ispunished[target] = false;
	}
	
	return Plugin_Handled;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////                MENUS                ///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

AfkEnd()
{
	// afk kill is identical to forfeit...except we print out different info.
	decl String:playername[64];
	GetClientName(g_currentturn, playername, sizeof(playername));
	PrintToChatAll("%s is afk. Ending the round.", playername);
	g_timeleft = 2;
	g_alreadyforfeited = true;
	ChangeClientTeam(g_currentturn, 1);
}

Forfeit()
{
	if (!g_alreadyforfeited)
	{
		decl String:playername[64];
		GetClientName(g_currentturn, playername, sizeof(playername));
		PrintToChatAll("%s has given up!", playername);
		if (g_timeleft > 6)
		{
			g_timeleft = 6;
		}
		g_alreadyforfeited = true;
	}
}

public Action:MenuCheck(client, args)
{
	if (client == g_currentturn)
	{
		MainMenu(client);
	}
	return Plugin_Handled;
}

public Action:ScoreCheck(client, args)
{
	ScoreMenu(client);
	return Plugin_Handled;
}

public Action:Top10Check(client, args)
{
	Top10(client);
	return Plugin_Handled;
}

Top10(client)
{
	BubbleSortScores();
	// while technically this should go under the "RANK" section, i feel its more fitting here...cant make it under both!
	new Handle:menu = CreateMenu(ScoreMenuHandler);
	SetMenuTitle(menu, "Top10");
	decl String:name[32];
	new score;
	decl String:format[64];
	new size = GetArraySize(g_playerscores);
	new endpoint;
	
	// if there's less then 10 people, let's not try to add 10 people, since it'll crash the server. only add as many as we can
	if (size < 30) // the reason it's 20 is because each player has 2 parts, steamid then points
	{
		endpoint = size;
	}
	else
	{
		endpoint = 30;
	}
	
	for (new i = size-3; i > size-endpoint-3; i=i-3)
	{
		GetArrayString(g_playerscores, i+2, name, sizeof(name));
		score = GetArrayCell(g_playerscores, i+1);
		Format(format, sizeof(format), "%s %i", name, score); // size-i is the current index (ie rank 1, rank 2, rank 3...etc)
		AddMenuItem(menu, name, format);
	}
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, 20);
}

ScoreMenu(client)
{
	new Handle:menu = CreateMenu(ScoreMenuHandler);
	SetMenuTitle(menu, "Score");
	decl String:name[32];
	new score;
	decl String:format[64];
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(client))
		{
			if (g_players_playing[i])
			{
				GetClientName(i, name, sizeof(name));
				score = GetArrayCell(g_playerscores, g_playerpoints[i]+1);
				Format(format, sizeof(format), "%s %i", name, score);
				AddMenuItem(menu, name, format);
			}
		}
	}
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, 20);
}

MainMenu(client)
{
	new Handle:menu = CreateMenu(MainMenuHandler);
	SetMenuTitle(menu, "Drawing Menu");
	AddMenuItem(menu, "size", "Pen Size");
	AddMenuItem(menu, "color", "Pen Color");
	AddMenuItem(menu, "undo", "Undo");
	AddMenuItem(menu, "forfeit", "Forfeit");
	AddMenuItem(menu, "eraseall", "Erase All");
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, 60);
}

SizeMenu(client)
{
	new Handle:menu = CreateMenu(SizeMenuHandler);
	SetMenuTitle(menu, "Size");
	AddMenuItem(menu, "1", "1");
	AddMenuItem(menu, "2", "2");
	AddMenuItem(menu, "3", "3");
	SetMenuExitBackButton(menu, true);
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, 60);
}

ColorMenu(client)
{
	new Handle:menu = CreateMenu(ColorMenuHandler);
	SetMenuTitle(menu, "Color");
	AddMenuItem(menu, "grey", "Grey");
	AddMenuItem(menu, "black", "Black");
	AddMenuItem(menu, "white", "White");
	AddMenuItem(menu, "red", "Red");
	AddMenuItem(menu, "green", "Green");
	AddMenuItem(menu, "blue", "Blue");
	AddMenuItem(menu, "yellow", "Yellow");
	AddMenuItem(menu, "orange", "Orange");
	AddMenuItem(menu, "purple", "Purple");
	AddMenuItem(menu, "pink", "Pink");
	AddMenuItem(menu, "brown", "Brown");
	SetMenuExitButton(menu, true);
	SetMenuExitBackButton(menu, true);
	DisplayMenu(menu, client, 60);
}

Undo()
{
	new size = GetArraySize(g_lasers) - 1;
	
	if (size < 0)
	{
		return;
	}
	new ent = GetArrayCell(g_lasers, size);
	RemoveFromArray(g_lasers, size);
	
	if (IsValidEdict(ent))
	{
		AcceptEntityInput(ent, "Kill"); 
	}
}
public ScoreMenuHandler(Handle:menu, MenuAction:action, client, param2)
{
	if (action == MenuAction_Cancel)
    {
        if (param2 == MenuCancel_ExitBack)
        {
            ScoreMenu(client);
        }
    }
	else if (action == MenuAction_End)
    {
        CloseHandle(menu);
    }
}

public ColorMenuHandler(Handle:menu, MenuAction:action, client, param2)
{
	if (client == g_currentturn)
	{
		if (action == MenuAction_Select)
		{
			if (param2 == 0) // grey
			{
				strcopy(g_colorchosen, sizeof(g_colorchosen), "draw/grey.vmt");
			}
			else if (param2 == 1) // black
			{
				strcopy(g_colorchosen, sizeof(g_colorchosen), "draw/black.vmt");
			}
			else if (param2 == 2) // white
			{
				strcopy(g_colorchosen, sizeof(g_colorchosen), "draw/white.vmt");
			}
			else if (param2 == 3) // red
			{
				strcopy(g_colorchosen, sizeof(g_colorchosen), "draw/red.vmt");
			}
			else if (param2 == 4) // green
			{
				strcopy(g_colorchosen, sizeof(g_colorchosen), "draw/green.vmt");
			}
			else if (param2 == 5) // blue
			{
				strcopy(g_colorchosen, sizeof(g_colorchosen), "draw/blue.vmt");
			}
			else if (param2 == 6) // yellow
			{
				strcopy(g_colorchosen, sizeof(g_colorchosen), "draw/yellow.vmt");
			}
			else if (param2 == 7) // orange
			{
				strcopy(g_colorchosen, sizeof(g_colorchosen), "draw/orange.vmt");
			}
			else if (param2 == 8) // purple
			{
				strcopy(g_colorchosen, sizeof(g_colorchosen), "draw/purple.vmt");
			}
			else if (param2 == 9) // pink
			{
				strcopy(g_colorchosen, sizeof(g_colorchosen), "draw/pink.vmt");
			}
			else if (param2 == 10) // brown
			{
				strcopy(g_colorchosen, sizeof(g_colorchosen), "draw/brown.vmt");
			}
			ColorMenu(client);
		}
		if (action == MenuAction_Cancel)
		{
			if (param2 == MenuCancel_ExitBack)
			{
				MainMenu(client);
			}
		}
		else if (action == MenuAction_End)
		{
			CloseHandle(menu);
		}
	}
}

public SizeMenuHandler(Handle:menu, MenuAction:action, client, param2)
{
	if (client == g_currentturn)
	{
		if (action == MenuAction_Select)
		{
			if (param2 == 0) // size == 1
			{
				g_lasersize = 1;
			}
			else if (param2 == 1) // size == 2
			{
				g_lasersize = 2;
			}
			else if (param2 == 2) // size == 3
			{
				g_lasersize = 3;
			}
			SizeMenu(client);
		}
		
		if (action == MenuAction_Cancel)
		{
			if (param2 == MenuCancel_ExitBack)
			{
				MainMenu(client);
			}
		}
		else if (action == MenuAction_End)
		{
			CloseHandle(menu);
		}
	}
}

public MainMenuHandler(Handle:menu, MenuAction:action, client, buttonnum)
{
	if (client == g_currentturn)
	{
		new bool:stayopen = true;
		if (action == MenuAction_Select)
		{
			if (buttonnum == 0)
			{
				stayopen = false;
				SizeMenu(client);
			}
			else if (buttonnum == 1)
			{
				stayopen = false;
				ColorMenu(client);
			}
			else if (buttonnum == 2)
			{
				Undo();
			}
			else if (buttonnum == 3)
			{
				Forfeit();
			}
			else if (buttonnum == 4)
			{
				EraseLasers();
			}
			
			if (stayopen)
			{
				MainMenu(client);
			}
		}
		if (action == MenuAction_End)
		{
			CloseHandle(menu);
		}
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////                RANK                ////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// We need to be able sort our array of points to find whos number 1 etc..
// Chose bubble sort because it's easy to implement, thats really it lol. it may not be the fastest, but it sure was the fastest to write! hah! Mergesort would blow my mind...
BubbleSortScores()
{
	if (g_playerscores != INVALID_HANDLE)
	{
		new size = GetArraySize(g_playerscores);
		// if there's nobody in the array, why would we sort it? lol
		if (size > 0)
		{
			new bool:swapped = false;
			decl String:jsteamid[32];
			decl String:jsteamid1[32];
			decl String:jname[32];
			decl String:jname1[32];
			// we increment by 2 because of the way the array is set up. first is steamid, then their score
			for (new i = 0; i <= size-6; i=i+3)
			{
				for (new j = 0; j <= size-6; j=j+3)
				{
					new jscore = GetArrayCell(g_playerscores, j+1);
					new jscore1 = GetArrayCell(g_playerscores, j+4);
					
					if (jscore > jscore1) // if A[j] > A[j + 1}
					{
						// put both in buffers
						GetArrayString(g_playerscores, j, jsteamid, sizeof(jsteamid));
						GetArrayString(g_playerscores, j+3, jsteamid1, sizeof(jsteamid1));
						
						GetArrayString(g_playerscores, j+2, jname, sizeof(jname));
						GetArrayString(g_playerscores, j+5, jname1, sizeof(jname1));
						
						// A[j] = A[j + 1]
						SetArrayString(g_playerscores, j, jsteamid1);
						SetArrayCell(g_playerscores, j+1, jscore1);
						SetArrayString(g_playerscores, j+2, jname1);
						
						// A[j + 1] = A[j]
						SetArrayString(g_playerscores, j+3, jsteamid);
						SetArrayCell(g_playerscores, j+4, jscore);
						SetArrayString(g_playerscores, j+5, jname);
						swapped = true;
					}
				}
				if (!swapped)
				{
					break;
				}
			}
			
			// if you remember, we store the players location in the array for simplicity, so now that we've sorted everyone, we must find the players again! (all stored in g_playerpoints)
			// but, since every players location (may) have changed, we must loop through all players and make sure we got them all!
			for (new i = 1; i <= MaxClients; i++)
			{
				if (IsClientInGame(i))
				{
					FindNewPlayerLocations(i);
				}
			}
		}
	}
}

FindNewPlayerLocations(client)
{
	if (g_playerscores != INVALID_HANDLE)
	{
		decl String:auth[32];
		GetClientAuthString(client, auth, sizeof(auth));
		new size = GetArraySize(g_playerscores);
		//new String:steamid[32];
		decl String:currentid[32];
		//GetClientAuthString(client, steamid, sizeof(steamid));
		
		for (new i = 0; i < size; i=i+3)
		{
			GetArrayString(g_playerscores, i, currentid, sizeof(currentid));
			if (strcmp(auth, currentid, true) == 0)
			{
				g_playerpoints[client] = i;
				decl String:playername[64];
				GetClientName(client, playername, sizeof(playername));
				SetArrayString(g_playerscores, i+2, playername);
				return;
			}
		}
		// if it made it this far, then we know the person is a NEWBY!!! :D
		// lets make that person a new spot in the array, oh boy
		
		new index = PushArrayString(g_playerscores, auth);
		PushArrayCell(g_playerscores, 0);
		
		decl String:playername[64];
		GetClientName(client, playername, sizeof(playername));
		PushArrayString(g_playerscores, playername);
		g_playerpoints[client] = index;
	}
	return;
}

DisplayRank(client)
{
	// Remember how we stored the players position within the giant array in g_playerpoints? Well if you didn't now you do lol. We can directly get their rank using that! Woohoo!
	// The #1 player is stored at the "top" of the array (highest number), so let's use that...
	BubbleSortScores();
	new size = GetArraySize(g_playerscores)/3; // The array will always divisible by three, since it's made from three parts (steamid is one index, points is next, playername last)
	new rank = size - (g_playerpoints[client]/3);
	new points = GetArrayCell(g_playerscores, g_playerpoints[client]+1); // we need the +1 because g_playerspoints[client] points first to their steamid, and next index is their points!
	decl String:playername[64];
	GetClientName(client, playername, sizeof(playername));
	
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i))
		{
			if (i == client)
			{
				PrintToChat(i, "You are ranked %i out of %i with %i points.", rank, size, points); // Bam! It's that easy.
			}
			else
			{
				PrintToChat(i, "%s is ranked %i out of %i with %i points.", playername, rank, size, points);
			}
		}
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////                DEBUG                ///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

public Action:GetIndex(client, args)
{
	// Prints out the location in the adt_array of a given player
	PrintToConsole(client, "%i", g_playerpoints[client]);
	return Plugin_Handled;
}

public Action:GetScores(client, args)
{
	// Prints to console everyones scores
	// WARNING: It will not send everyones if the array is too large
	new size = GetArraySize(g_playerscores);
	decl String:arraystring[32];
	decl String:playername[64];
	decl String:formated[64];
	new arraycell;
	for (new i = 0; i < size; i=i+3)
	{
		GetArrayString(g_playerscores, i, arraystring, sizeof(arraystring));
		arraycell = GetArrayCell(g_playerscores, i+1);
		GetArrayString(g_playerscores, i+2, playername, sizeof(playername));
		Format(formated, sizeof(formated), "%s %s %i", arraystring, playername, arraycell);
		PrintToConsole(client, "%s", formated);
	}
	return Plugin_Handled;
}

public Action:PrintRecent(client, args)
{
	// Prints out the numerical value of the most recently used words
	for (new i = 0; i < 100; i++)
	{
		PrintToConsole(client, "%i", g_recentlydone[i]);
	}
	return Plugin_Handled;
}

public Action:FakeWin(client, args)
{
	// Wins the round immediately.
	if (!g_firstguess)
	{
		g_wordguessed[client] = 1;
		//g_wordguessed[g_currentturn] = 2;
		g_firstguess = true;
	}
	else
	{
		g_wordguessed[client] = 3;
	}
	g_istherewinner = true;
	return Plugin_Handled;
}

public Action:Erase(client, args)
{
	// Prints out all entities class type
	decl String:classname[64];
	for (new i = 0; i < GetMaxEntities(); i++)
	{
		if(!IsValidEntity(i))
		{
			continue;
		}
		
		GetEdictClassname(i,classname,sizeof(classname));
		
		PrintToConsole(client, "%s", classname);
	}
	return Plugin_Handled;
}

public Action:HintCheck(client, args)
{
	// Prints out the hint
	for (new i = 0; i < strlen(g_word); i++)
	{
		PrintToConsole(client, "Letter %i is %b", i, g_wordhint[i]);
	}
	return Plugin_Handled;
}